Attribute VB_Name = "FileVersion"
Private Type VS_FIXEDFILEINFO
    dwSignature As Long
    dwStrucVersion As Long
    dwFileVersionMSl As Integer
    dwFileVersionMSh As Integer
    dwFileVersionLSl As Integer
    dwFileVersionLSh As Integer
    dwProductVersionMSl As Integer
    dwProductVersionMSh As Integer
    dwProductVersionLSl As Integer
    dwProductVersionLSh As Integer
    dwFileFlagsMask As Long
    dwFileFlags As Long
    dwFileOS As Long
    dwFileType As Long
    dwFileSubtype As Long
    dwFileDateMS As Long
    dwFileDateLS As Long
End Type

Private Declare Function GetFileVersionInfo _
    Lib "Version.dll" Alias _
    "GetFileVersionInfoA" (ByVal lptstrFilename As String, _
                           ByVal dwHandle As Long, _
                           ByVal dwLen As Long, _
                           lpData As Any _
     ) As Long

Private Declare Function GetFileVersionInfoSize Lib "Version.dll" _
    Alias "GetFileVersionInfoSizeA" ( _
                            ByVal lptstrFilename As String, _
                            lpdwHandle As Long _
    ) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
            dest As Any, src As Long, ByVal length As Long)

Private Declare Function VerQueryValue Lib "Version.dll" Alias "VerQueryValueA" _
    (pBlock As Any, _
      ByVal lpSubBlock As String, _
      lplpBuffer As Any, _
      puLen As Long _
     ) As Long

Private Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128      '  Maintenance string for PSS usage
End Type

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Public Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long

Private Const VER_PLATFORM_WIN32_NT = 2
Private Const VER_PLATFORM_WIN32_WINDOWS = 1


'Karl Moore - http://www.vb-world.net/files/tip525.html
Public Function GetVersionInfo(ByVal sFile As String) As String

    Dim lDummy As Long
    Dim sBuffer() As Byte
    Dim lBufferLen As Long, lVerPointer As Long
    Dim lVerBufferLen As Long
    Dim udtVerBuffer As VS_FIXEDFILEINFO
    
    'Default return value
    GetVersionInfo = "N/A"
    
    'Attempt to retrieve version resource
    lBufferLen = GetFileVersionInfoSize(sFile, _
    lDummy)
    
    If lBufferLen > 0 Then
        
        ReDim sBuffer(lBufferLen)
        
        If GetFileVersionInfo(sFile, 0&, _
            lBufferLen, sBuffer(0)) <> 0 Then
            
            If VerQueryValue(sBuffer(0), _
                "\", lVerPointer, lVerBufferLen) _
                <> 0 Then
        
                CopyMemory udtVerBuffer, ByVal _
                    lVerPointer, Len(udtVerBuffer)
                    
                With udtVerBuffer
                    GetVersionInfo = _
                        .dwFileVersionMSh & "." & _
                        .dwFileVersionMSl & "." & _
                        .dwFileVersionLSh & "." & _
                        .dwFileVersionLSl
                End With
        
            End If
        End If
    End If

End Function


Function SysVersion() As String
   Dim myVer As OSVERSIONINFO
    
   myVer.dwOSVersionInfoSize = 148
   Call GetVersionEx&(myVer)
   
   If myVer.dwPlatformId = 2 Then tmp = "WinNT " Else tmp = "Win9x"
   
   tmp = tmp & myVer.dwMajorVersion & "." & myVer.dwMinorVersion & _
        "   Build: " & (myVer.dwBuildNumber And &HFFFF) & "  " & Replace(myVer.szCSDVersion, Chr(0), "")
    
   SysVersion = CStr(tmp)
End Function

Function GetCompName() As String
    Dim strString As String
    strString = String(255, Chr$(0))
    GetComputerName strString, 255
    strString = Left$(strString, InStr(1, strString, Chr$(0)) - 1)
    GetCompName = strString
End Function
